#ifndef DEFINE_H_VOBJ
#define DEFINE_H_VOBJ

#include <basic.h>
#include <bstdio.h>
#include <bstring.h>
#include <btron/vobj.h>
#include <list>
#include <vector>

/*!
 * Ȱʬι¤
 */
class Vobj {

  VID   vid;
  VLINK vlink;
  VOBJSEG *vseg;

public:

  Vobj(VID avid, const VLINK& avlink, const VOBJSEG *avseg, const PNT& pos);

  Vobj(VID avid, const VLINK& avlink, const VOBJSEG *avseg);

  Vobj(VID avid);

  virtual ~Vobj() {
      odel_vob(vid, 0);
      delete [] reinterpret_cast<UB*>(vseg);
  }

  VID getVID() const { return vid; }

  //const PNT& getPos() const;

  const VOBJSEG* getVseg() const {
    return vseg;
  }

  const VLINK* getVlink() const {
    return &vlink;
  }

  const RECT& getRect() const {
    return vseg->view;
  }

  void move(WID wid, W vcode, RECT* org);

  void refreshData();

  Vobj* duplicate() const;

  Vobj* duplicateRobj() const;

  Vobj* duplicateRobj(WID wid) const;

};

/*!
 * Ȥνι¤
 */
class VobjSet {

public:

  typedef std::list<Vobj*> VobjList;
  typedef std::vector<VobjList> VobjPageList;

private:

  mutable bool changed;

  VobjPageList vls;

  struct VobjDataHeader {
    W id;
    W len;
    W page;
    // -- VOBJSEG to be continued after this
  };

public:

  VobjSet(int nPages) : changed(false), vls(nPages) {}
  virtual ~VobjSet();

  void clear();

  void displayPage(int pg, double zoom, UW disp = V_DISPALL) const;

  Vobj* add(W wid, const VLINK* vlink, const VOBJSEG* vseg, 
            const PNT& pos, int destpage, int curpage, double zoom);

  void add(Vobj* vobj, int page);

//  const Vobj* searchVobj(VID vid) const;

  void remove(VID vid, int page);

  Vobj* findVobj(int pg, const PNT& p);

  void setChanged() const {
    changed = true;
  }

  void clearChanged() const {
    changed = false;
  }

  bool isChanged() const {
    return changed;
  }

  void save(const LINK* link) const;

  void load(W wid, const LINK* link);
};


#endif // DEFINE_H_VOBJ
