/*!
 * @file ZoomMenu.cc
 * @brief ˥塼()
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-10-31, first edition (for BSlide)
 * @date 2005-02-27, modified for Scribble
 * @date 2006-05-08, modified for MicroPDF, removed a bug
 *
 * Copyright (C) 2004-2006, Yashiro Takeshi
 */

#include <basic.h>
#include <btron/hmi.h>
#include <btron/vobj.h>
#include <btron/libapp.h>
#include "ZoomMenu.h"
#include "tcsliteral.h"
#include "Exception.h"
#include "databox.h"
#include "GString.h"
#include "GlobalParams.h"

static TC m_zoom[]  = {TCS_MENU_ZOOM};

static MENUITEM mitems[] = {
  {0L, 0L, 0, 0, m_zoom},
};

ZoomMenu::ZoomMenu()
: mid(-1)
{
  vmap.insert(std::make_pair(1, 400));
  vmap.insert(std::make_pair(2, 300));
  vmap.insert(std::make_pair(3, 200));
  vmap.insert(std::make_pair(4, 150));
  vmap.insert(std::make_pair(5, 125));
  vmap.insert(std::make_pair(6, 100));
  vmap.insert(std::make_pair(7, 75));
  vmap.insert(std::make_pair(8, 50));
  vmap.insert(std::make_pair(9, 25));
  
  mid = mcre_men(sizeof(mitems)/sizeof(MENUITEM), mitems, NULL);
  if (mid < 0){
    throw UserException(-2);
  }
}

// ˥塼ܤͤμ
double ZoomMenu::getZoomVal(int rid) const
{
  ValueMap::const_iterator p = vmap.find(rid);
  if (p != vmap.end()){
    return p->second;
  }
  return atof(globalParams->getInitialZoom()->getCString());
}

// ˥塼ɥɽ
W ZoomMenu::popupMenu(W wid, double zoom)
{
  WDSTAT wds;

  setpointer(PS_SELECT, NULL);
  gdsp_ptr(-1);

  wget_sts(wid, &wds, NULL);
  wds.r.c.left += CTL_ZOOMBTN_X + 6;
  wds.r.c.top += CTL_SWITCH_BOTTOM;

  mchg_atr(mid, 1, ((zoom == 400) ? M_SEL : M_NOSEL));
  mchg_atr(mid, 2, ((zoom == 300) ? M_SEL : M_NOSEL));
  mchg_atr(mid, 3, ((zoom == 200) ? M_SEL : M_NOSEL));
  mchg_atr(mid, 4, ((zoom == 150) ? M_SEL : M_NOSEL));
  mchg_atr(mid, 5, ((zoom == 125) ? M_SEL : M_NOSEL));
  mchg_atr(mid, 6, ((zoom == 100) ? M_SEL : M_NOSEL));
  mchg_atr(mid, 7, ((zoom ==  75) ? M_SEL : M_NOSEL));
  mchg_atr(mid, 8, ((zoom ==  50) ? M_SEL : M_NOSEL));
  mchg_atr(mid, 9, ((zoom ==  25) ? M_SEL : M_NOSEL));

  return msel_men(mid, wds.r.p.lefttop);
}

